#!/usr/bin/env bash
#
# orthologer - Pipeline for deducing orthology from fasta files.
# Copyright (C) 2005-2023 E. Zdobnov lab: F. Tegenfeldt
# <fredrik.tegenfeldt@unige.ch> based on code by E. Kriventseva
#
# This file is part of orthologer.
#
# orthologer is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# orthologer is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with orthologer.  If not, see <http://www.gnu.org/licenses/>.
#
#--- check if environment is ok -----------------
[ "${LOADED_COMMON_PIPELINE_SH+1}" == "" ] && echo "ERROR $0 : main config has not been loaded" 1>&2 && exit 255
#------------------------------------------------
set -u

# get args
if [ $# -ne 1 ]; then
    echo "Usage: $0 <label>"
    exit 255
fi

input="$1"
inparr=( $(tokenize ";" $input) )

nok=0
nerr=0
ec=0

cmd="$DIR_ORTHOLOGER_BIN/check_fasta.py"
check_file_exe "$0" "$cmd" || exit 254


# loop over set of arguments separated by ';'
for args in ${inparr[@]}; do
    echo
    print_separator
    info_msg "Starting STATS job <$args>"
    print_separator
    echo

    fsel="$DIR_PROJECT_SEQUENCES/${args}.$EXT_FASTA_SELECTED"
    [[ -f $fsel ]] || {error_msg "fasta_stats.sh: missing file $(trim_name $fsel)"; continue; }

    # check for end tag
    check_footer "$fsel" || fatal_msg "fasta_stats : missing end tag (#END) in <$fsel>"
    
    # process data
    tmp_make tmpfile fasta_stats
    startdate=$(date)
    output=$(set_extension "$fasta" "${EXT_FASTA_STATS}")

    tA=$(time_msec)
    $PYTHON3 $cmd --stats -f "$fsel" > $tmpfile
    ec=$?
    dT=$(delta_time $tA)

    if [[ $ec -eq 0 ]]; then
        nok=$((nok+1))
    else
        nerr=$((nerr+1))
    fi

    if [[ $ec -eq 0 ]]; then
        # add header and footer
        add_header_footer $0 $tmpfile "$output" "$startdate" $dT "$cmd --stats -f \"$fasta\""
        if [ $? -ne 0 ]; then
            exit 255
        fi

        chmod 644 "$output"
    fi
    echo
    print_separator
    info_msg "Done STATS job <$args>"
    print_separator
done
echo
[ $nerr -eq 0 ] || { info_msg "Completed $nok succesfully and $nerr with errors"; exit 255; }

